image: ruby:3.1.2

stages:
  - build
  - test
  - deploy
  - notifications

cache:
  paths:
    - vendor/

before_script:
  - gem install bundler
  - bundle install

pages:
  stage: deploy
  script:
    - bundle exec jekyll build -d public
  artifacts:
    paths:
      - public
  rules:
    - if: '$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH'

pages:test:
  stage: test
  script:
    - bundle exec jekyll build -d public
  artifacts:
    paths:
      - test
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
    - if: '$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH'

notify-slack:
  image: alpine:3.17
  stage: notifications
  before_script:
    - apk add --no-cache curl git
  script:
    - ./scripts/notify-devops.sh
  rules:
    - if: '$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH'
      when: on_success

